package cc.fascinated.bat.features.logging;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * @author Fascinated (fascinated7)
 */
@AllArgsConstructor @Getter
public enum LogCategory {
    MESSAGE("Message"),
    MEMBER("Member"),
    CHANNEL("Channel");

    /**
     * The name of the log category
     */
    private final String name;

    /**
     * Gets the log category by the name
     *
     * @param name - the name
     * @return the log category, or null if it doesn't exist
     */
    public static LogCategory getLogCategory(String name) {
        for (LogCategory logCategory : values()) {
            if (logCategory.getName().equalsIgnoreCase(name)) {
                return logCategory;
            }
        }
        return null;
    }
}
